        CBLOCK 0x71
                lcd_temp0
                lcd_temp1
        ENDC
LCD_SEND:
	movwf	lcd_temp0		
	bcf	LCD_D7			
	bcf	LCD_D6
	bcf	LCD_D5
	bcf	LCD_D4
	btfsc	lcd_temp0,7		
	bsf	LCD_D7
	btfsc	lcd_temp0,6
	bsf	LCD_D6
	btfsc	lcd_temp0,5
	bsf	LCD_D5
	btfsc	lcd_temp0,4
	bsf	LCD_D4
	bsf	LCD_E			
	goto	$+1
	bcf	LCD_E

	bcf	LCD_D7			
	bcf	LCD_D6
	bcf	LCD_D5
	bcf	LCD_D4
	btfsc	lcd_temp0,3		
	bsf	LCD_D7
	btfsc	lcd_temp0,2
	bsf	LCD_D6
	btfsc	lcd_temp0,1
	bsf	LCD_D5
	btfsc	lcd_temp0,0
	bsf	LCD_D4
	bsf	LCD_E			
	goto	$+1
	bcf	LCD_E
	return

LCD_SENDINS:
	bcf	LCD_RS		
	call	LCD_SEND		
	call	LCD_SHORTDELAY	
	return

; Send a character to the LCD
LCD_PUTCH:
	bsf	LCD_RS			
	call	LCD_SEND		
	call	LCD_SHORTDELAY	
	return

; Initialize the LCD
__LCD_INIT:
	bcf	LCD_D7		
	bcf	LCD_D6
	bcf	LCD_D5
	bcf	LCD_D4
	bcf	LCD_RS			
	bcf	LCD_E
	call	LCD_LONGDELAY		
	movlw	B'00110011'		
	call	LCD_SENDINS
	movlw	B'00110011'		
	call	LCD_SENDINS
	movlw	B'00110010'		
	call	LCD_SENDINS
	movlw	B'00101100'		
	call	LCD_SENDINS
	movlw	B'00000110'		
	call	LCD_SENDINS
	movlw	B'00001100'		
	call	LCD_SENDINS
	movlw	B'00000001'		
	call	LCD_SENDINS
	movlw	B'00000010'		
	call	LCD_SENDINS
	call	LCD_LONGDELAY		
	return

; Long delay for init

LCD_LONGDELAY:
	movlw	.3
	movwf	lcd_temp0
LCD_LONGDEL:
	clrf	lcd_temp1
LCD_SHORTDEL:
	decfsz	lcd_temp1,F
	goto	LCD_SHORTDEL
	decfsz	lcd_temp0,F
	goto	LCD_LONGDEL
	return

; Short delay between commands (50s)
; oscillateur 1Mhz; on suppose qu'il peut tourner 2x plus vite
; dure cycle = 0,5s*4 = 2s
;
LCD_SHORTDELAY:
	movlw	.12
	movwf	lcd_temp1
LCD_SHORTLOOP:
	decfsz	lcd_temp1,F
	goto	LCD_SHORTLOOP
	return

